# Google Spanner

### Overview

This guide outlines the configuration steps for adding Google Spanner as a resource in StrongDM.

When the resource is added, StrongDM proxies client connections through a node (gateway, relay, or proxy cluster). This enables centralized access control, credential management, and audit logging. Once configured, you can connect to Spanner using the StrongDM Desktop application or StrongDM CLI and run queries through StrongDM.

For general information about how to add a database as a resource in StrongDM, see our main guide, [Add a Datasource](https://docs.strongdm.com/admin/resources/datasources).

## Supported Versions and Clients

StrongDM supports all generally available versions of Google Cloud Spanner. Because Spanner is a managed service, version compatibility is handled by Google, and StrongDM integrates with Spanner using Google’s stable service endpoint.

StrongDM is generally compatible with standard Spanner clients and drivers, including:

* GUI SQL tools that support Spanner connectivity
* Application drivers that use Spanner APIs through StrongDM networking
* The StrongDM Desktop application and CLI for access and session management

## Prerequisites

To add your resource in StrongDM, you need to meet several technical and configuration prerequisites. Please ensure that the following requirements are met.

In StrongDM, you must have the following:

* Administrator permission level
* At least one operational StrongDM node (gateway, relay, or proxy cluster) deployed in a location that can reach the Spanner endpoint
* (Optional) A configured Secret Store in StrongDM, if you plan to reference credentials from a secret manager
* A way to test connectivity to Spanner independently of StrongDM (recommended)

{% hint style="info" %}
To verify that the resource is accessible by the node, log in to the gateway or relay and use Netcat: `nc -zv <HOSTNAME> <PORT>` (in this example, `nc -zv testdb-01.fancy.org 3306`). If your gateway server can connect to this hostname, proceed.

Netcat is a tool for checking various hostnames and ports by either sending data (a ping) or checking for listeners on the ports. The command in the aforementioned example use "-z" to check for listeners without sending data and "-v" to show verbose output. If you don't have Netcat, you can install the Netcat package with whatever package manager you are using, such as "apt-get install netcat".
{% endhint %}

On the GCP side, you must have the following:

* Google Cloud project with Cloud Spanner enabled
* Spanner instance and database you intend to connect to
* Identity with sufficient permissions to access the database (for example, roles that allow read/query access)
* If using service account impersonation, ensure your node’s runtime identity is allowed to impersonate the target service account (and that the target has appropriate Spanner permissions). This typically requires granting the Service Account Token Creator role on the target service account. Please see the Google documentation for more information about [service account impersonation](https://cloud.google.com/iam/docs/service-account-impersonation) and the [role/permission](https://cloud.google.com/iam/docs/service-account-permissions) needed.
* StrongDM node (relay or gateway) configured with a Google service account identity that has permission to access Cloud Spanner

{% hint style="info" %}
Note: The StrongDM node does not need to run in Google Cloud, but it must be able to reach the Spanner API endpoint and authenticate using a service account.
{% endhint %}

## Resource Management in StrongDM

After all prerequisites are met and prep work is done, you are ready to add the resource to StrongDM. This section provides instructions for adding the resource in either the StrongDM Admin UI, CLI, Terraform provider, or SDKs.

{% tabs %}
{% tab title="Admin UI" %}
**Set up and Manage With the Admin UI**

If using the Admin UI to add BigQuery as a resource to StrongDM, use the following steps.

1. Log in to the StrongDM Admin UI.
2. Go to **Resources** > **Managed Resources**.
3. Click **Add Resource**.
4. For **Resource Type**, select **Google Spanner**.
5. Complete all required [configuration properties](#configuration-properties) for your selected datasource type.
6. Click **Create** to save the resource.
7. Click the resource name to view status, diagnostic information, and setting details.
   {% endtab %}

{% tab title="CLI" %}
**Set up and Manage With the CLI**

This section provides an example of how to add the resource using the StrongDM CLI. For more information and examples, please see the [CLI Reference](https://app.gitbook.com/s/4XOJmXFslCMVCzIG2rKp/cli) documentation.

```
# Add a Google Spanner datasource
sdm admin datasources add spanner spanner-prod
  --endpoint="spanner.googleapis.com"
  --project="my-gcp-project"
  --instance-id="my-spanner-instance"
  --database="my-spanner-database"
  --service-account-to-impersonate="spanner-access@my-gcp-project.iam.gserviceaccount.com"
  --egress-filter="tag:env=prod"
  --port-override="0"
  --proxy-cluster-id="n-1a2b345c67890123"
  --tags="env=production,team=data"

```

{% endtab %}

{% tab title="Terraform" %}
**Set up and Manage With Terraform**

This section provides an example of how to configure and manage the resource using the Terraform provider. For more information and examples, please see the [Terraform provider](https://github.com/strongdm/terraform-provider-sdm) documentation.

```tf
# Install StrongDM provider
terraform {
  required_providers {
    sdm = {
      source  = "strongdm/sdm"
      version = "16.5.0"
    }
  }
}

# Configure StrongDM provider
provider "sdm" {
  # Add API access key and secret key from Admin UI
  api_access_key = "njjSn...5hM"
  api_secret_key = "ziG...="
}

# Create Google Spanner datasource
resource "sdm_spanner" "spanner_prod" {
  name = "spanner-prod"
  endpoint = "spanner.googleapis.com"
  project = "my-gcp-project"
  instance_id = "my-spanner-instance"
  database = "my-spanner-database"
  # Optional: use impersonation
  service_account_to_impersonate = "spanner-access@my-gcp-project.iam.gserviceaccount.com"

  # Networking / routing / metadata
  egress_filter = "tag:env=prod"
  port_override = 0
  proxy_cluster_id = "n-1a2b345c67890123"
  tags = {
    env = "production"
    team = "data"
    }
  }
```

{% endtab %}

{% tab title="SDKs" %}
**Set up and manage with SDKs**

In addition to the Admin UI, CLI, and Terraform, you may configure and manage your resource with any of the following SDK options: Go, Java, Python, and Ruby. Please see the following references for more information and examples.

| Language      | Reference                                                                | GitHub                                                                 | Examples                                                                        |
| ------------- | ------------------------------------------------------------------------ | ---------------------------------------------------------------------- | ------------------------------------------------------------------------------- |
| Go            | [pkg.go.dev](https://pkg.go.dev/github.com/strongdm/strongdm-sdk-go/v16) | [strongdm-sdk-go](https://github.com/strongdm/strongdm-sdk-go)         | [Go SDK Examples](https://github.com/strongdm/strongdm-sdk-go-examples)         |
| Java          | [javadoc](https://strongdm.github.io/strongdm-sdk-java-docs/)            | [strongdm-sdk-java](https://github.com/strongdm/strongdm-sdk-java)     | [Java SDK Examples](https://github.com/strongdm/strongdm-sdk-java-examples)     |
| Python        | [pdocs](https://strongdm.github.io/strongdm-sdk-python-docs/)            | [strongdm-sdk-python](https://github.com/strongdm/strongdm-sdk-python) | [Python SDK Examples](https://github.com/strongdm/strongdm-sdk-python-examples) |
| Ruby          | [RubyDoc](https://www.rubydoc.info/gems/strongdm)                        | [strongdm-sdk-ruby](https://github.com/strongdm/strongdm-sdk-ruby)     | [Ruby SDK Examples](https://github.com/strongdm/strongdm-sdk-ruby-examples)     |
| {% endtab %}  |                                                                          |                                                                        |                                                                                 |
| {% endtabs %} |                                                                          |                                                                        |                                                                                 |

## **Configuration Properties**

The following configuration properties control how StrongDM connects to the database and authenticates the connection.

<table><thead><tr><th width="199.6640625">Property</th><th width="130.4609375">Requirement</th><th>Description</th></tr></thead><tbody><tr><td><strong>Display Name</strong></td><td>Required</td><td>Meaningful name to display the resource throughout StrongDM; exclude special characters like quotes (") or angle brackets (&#x3C; or >)</td></tr><tr><td><strong>Resource Type</strong></td><td>Required</td><td><strong>Google Spanner</strong></td></tr><tr><td><strong>Proxy Cluster</strong></td><td>Required</td><td>Defaults to "None (use gateways)"; if using <a href="../../networking/proxy-clusters">proxy clusters</a>, select the appropriate cluster to proxy traffic to this resource</td></tr><tr><td><strong>Endpoint</strong></td><td>Required</td><td>Endpoint (for example, <code>spanner.googleapis.com</code>), which <a href="#prerequisites">must be accessible</a> to a gateway or relay</td></tr><tr><td><strong>Port</strong></td><td>Optional</td><td>Port to use when connecting to your resource</td></tr><tr><td><strong>Connectivity Mode</strong></td><td>Required</td><td>Select either <strong>Virtual Networking Mode</strong>, which lets users connect to the resource with a software-defined, IP-based network; or <strong>Loopback Mode</strong>, which allows users to connect to the resource using the local loopback adapter in their operating system; this field is shown if <a href="../../clients/client-networking/virtual-networking-mode">Virtual Networking Mode</a> enabled for your organization</td></tr><tr><td><strong>IP Address</strong></td><td>Optional</td><td>If <strong>Virtual Networking Mode</strong> is the selected connectivity mode, an IP address value in the configured Virtual Networking Mode subnet in the organization network settings; if <strong>Loopback Mode</strong> is the selected connectivity mode, an IP address value in the configured Loopback IP range in the organization network settings (by default, <code>127.0.0.1</code>); if not specified, an available IP address in the configured IP address space for the selected connectivity mode will be automatically assigned; this field is shown if <a href="../../clients/client-networking/virtual-networking-mode">Virtual Networking Mode</a> and/or <a href="../../clients/client-networking/loopback-ip-ranges">multi-loopback mode</a> is enabled for your organization</td></tr><tr><td><strong>Port Override</strong></td><td>Optional</td><td>If <strong>Virtual Networking Mode</strong> is the selected connectivity mode, a port value between 1 and 65535 that is not already in use by another resource with the same IP address; if <strong>Loopback Mode</strong> is the selected connectivity mode, a port value between 1024 to 64999 that is not already in use by another resource with the same IP address; when left empty with Virtual Networking Mode, the system assigns the default port to this resource; when left empty for Loopback Mode, an available port that is not already in use by another resource is assigned; preferred port also can be modified later from the <a href="../port-overrides">Port Overrides settings</a></td></tr><tr><td><strong>DNS Subdomain</strong></td><td>Optional</td><td>If Virtual Networking Mode is the selected connectivity mode, a unique hostname alias for this resource; when set, causes the desktop app to display this resource's human-readable DNS name (for example, <code>k8s.my-organization-name</code>) instead of the bind address that includes IP address and port (for example, <code>100.64.100.100:5432</code>)</td></tr><tr><td><strong>Project</strong></td><td>Required</td><td>Project identifier that is configured for the database (for example, <code>my-gcp-project</code>)</td></tr><tr><td><strong>Instance ID</strong></td><td>Required</td><td>Spanner instance ID (for example, <code>my-spanner-instance-id</code>)</td></tr><tr><td><strong>Service Account to Impersonate</strong></td><td>Optional</td><td>If set, the service account that the relay will impersonate when accessing Spanner</td></tr><tr><td><strong>Database</strong></td><td>Required</td><td>Name of the database to connect to using this resource</td></tr><tr><td><strong>Resource Tags</strong></td><td>Optional</td><td>Datasource consisting of key-value pairs <code>&#x3C;KEY>=&#x3C;VALUE></code> (for example, <code>env=dev</code>)</td></tr></tbody></table>

### Resource status

After a resource is created, the Admin UI displays that resource as unhealthy until the healthchecks run successfully. When the resource is ready, the **Health** icon indicates a positive, green status.

When the resource does not display a positive status, click the resource name to go to the **Diagnostics** tab and check for errors.

## Test the Connection

After you have added your resource in StrongDM, follow these steps to verify that it’s working correctly.

1. Assign yourself access by ensuring that your user or role has access to the resource. In the StrongDM Admin UI, go to **Access** > **Roles**, and verify that the resource is attached to a role you’re in.
2. In the CLI, run `sdm status` to list the available datasources. Confirm that the resource is available.
3. Start a session. For example:

   ```bash
   sdm connect spanner-prod
   ```
4. Run a test query, as in the following example:

   ```sql
   SELECT CURRENT_DATE();
   ```
5. In the StrongDM Admin UI, check **Logs > Queries** (and **Logs > Connections**) to verify your query was captured.

When these steps succeed, you’re ready to connect to your resource through StrongDM.

### Help

If you encounter issues, please consult the [StrongDM Help Center](https://help.strongdm.com/hc/en-us).

Be prepared to provide the following information to StrongDM Support, so that they can inspect logs and confirm node and resource health:

* Resource name or ID
* CLI error output or logs
* Node name and region


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.strongdm.com/admin/resources/datasources/google-spanner.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
